<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:h="http://java.sun.com/jsf/html"
      xmlns:f="http://java.sun.com/jsf/core"
      xmlns:ui="http://java.sun.com/jsf/facelets"
      xmlns:a4j="http://richfaces.org/a4j"
      xmlns:rich="http://richfaces.org/rich"
      xmlns:c="http://java.sun.com/jsp/jstl/core"
      xmlns:notifications="http://java.sun.com/jsf/composite/components/org/inra/ecoinfo/notifications"
      xmlns:identification="http://java.sun.com/jsf/composite/components/org/inra/ecoinfo/identification"
      xmlns:popups="http://java.sun.com/jsf/composite/components/org/inra/ecoinfo/popups">
    <h:outputStylesheet library="css" name="extraction/#{css}" />

    <a4j:jsFunction name="selectTaxonVO" execute="@this,parametersRequest"
                    action="#{uiBean.selectTaxonVO}"
                    render="formExtraction:listTaxons,parametersRequest, nextStepButton,messageWarningStep3"
                    limitRender="true">
        <a4j:param name="param1" assignTo="#{uiBean.idTaxonVOSelected}" />
    </a4j:jsFunction>

    <a4j:jsFunction name="updateTaxonList" execute="@this,parametersRequest"
                    action="#{uiBean.updateTaxonList}"
                    render="rechercheLibre,parametersRequest,messageWarningStep3"
                    limitRender="true">
        <a4j:param name="param1" assignTo="#{uiBean.taxonSearch}" />
    </a4j:jsFunction>




    <a4j:jsFunction name="updateCheckDetailsTaxon" execute="@this"
                    action="#{uiBean.updateCheckDetailsTaxon}"
                    render="panelDetailTaxon"
                    limitRender="true">	
    </a4j:jsFunction>

    <a4j:jsFunction name="updateCheckDetailsStades" execute="@this"
                    action="#{uiBean.updateCheckDetailsStadeDevelopment}"
                    render="panelDetailStadeDeveloppement"
                    limitRender="true">	
    </a4j:jsFunction>

    <f:loadBundle
        basename="org.inra.ecoinfo.zooplancton.jsf.taxonchoicestep"
        var="taxonchoicestep" />
    <h:panelGroup id="messageWarningStep3">
        <h:outputText value="#{taxonchoicestep.PROPERTY_MSG_CHOOSE_TAXON}"
                      rendered="#{not uiBean.parametersRequest.taxonStepIsValid}"
                      styleClass="selectionEmpty" />
    </h:panelGroup>

    <h:panelGroup styleClass="panelControlsWrapper-taxa" layout="block">
        <h:panelGroup styleClass="panelControls">
            <h:panelGroup styleClass="control" id="panelGenre" layout="block">
                <h:selectBooleanCheckbox id="genreBox" value="#{uiBean.genre}"
                                         title="#{taxonchoicestep.PROPERTY_MSG_SEARCH_GENDER_TITLE}">

                    <a4j:ajax event="click" execute="@this"
                              render="panelGenre, lenghtList, rechercheLibre"
                              status="statusWaitModal" />
                </h:selectBooleanCheckbox>
                <h:outputLabel value="#{taxonchoicestep.PROPERTY_MSG_SEARCH_GENDER}" for="genreBox"/>
            </h:panelGroup>
            <h:panelGroup styleClass="control" layout="block">
                <a4j:commandLink
                    execute="@this,parametersRequest,tree,treePreselection"
                    limitRender="true" action="#{uiBean.addAllTaxons}"
                    render="listTaxons,parametersRequest, prevStepButton, nextStepButton, validImage, messageWarningStep3,tree, panelSomme, panelDetail">
                    <h:graphicImage value="#{resource['images:add.png']}" />
                    <h:outputText value="#{taxonchoicestep.PROPERTY_MSG_ALL_TAXON}" />
                </a4j:commandLink>
            </h:panelGroup>
            <h:panelGroup styleClass="control" layout="block">
                <a4j:commandLink execute="@this,parametersRequest,tree"
                                 limitRender="true" action="#{uiBean.removeAllTaxons}"
                                 render="listTaxons,parametersRequest, prevStepButton, nextStepButton, validImage, messageWarningStep3,tree">
                    <h:graphicImage value="#{resource['images:remove_selection.png']}" />
                    <h:outputText value="#{taxonchoicestep.PROPERTY_MSG_CLEAR_SELECT}" />
                </a4j:commandLink>
            </h:panelGroup>
        </h:panelGroup>

        <h:panelGroup styleClass="panelControlsLeft">


            <h:panelGroup styleClass="control" id="panelDetailTaxon"
                          layout="block">

                <h:selectBooleanCheckbox value="#{uiBean.detailTaxon}"
                                         id="chkbxDetailTaxon"
                                         title="#{taxonchoicestep.MSG_DETAIL_TAXA_BRANCHE_TITLE}">
                    <a4j:ajax event="click" execute="@this" render="panelDetail" oncomplete="updateCheckDetailsStades()"/>
                </h:selectBooleanCheckbox>
                <h:outputLabel value="#{taxonchoicestep.MSG_DETAIL_TAXA_BRANCHE}"
                               for="chkbxDetailTaxon" />
            </h:panelGroup>
            <h:panelGroup styleClass="control" id="panelDetailStadeDeveloppement"
                          layout="block">  
                <h:selectBooleanCheckbox value="#{uiBean.detailStadeDeveloppement}" id="chkbxDetailStage"   
                                         title="#{taxonchoicestep.MSG_DETAIL_STAGE_BRANCHE_TITLE}">
                    <a4j:ajax event="click" execute="@this,chkbxDetailTaxon" render="panelDetail" oncomplete="updateCheckDetailsTaxon();" />
                </h:selectBooleanCheckbox>
                <h:outputLabel value="#{taxonchoicestep.MSG_DETAIL_STAGE_BRANCHE}" for="chkbxDetailStage"/>

            </h:panelGroup>

        </h:panelGroup>
    </h:panelGroup>

    <rich:tabPanel switchtype="client" id="listTaxons"
                   styleClass="panelTaxons">
        <rich:tab header="#{taxonchoicestep.PROPERTY_MSG_TAXON_PRESELECT}">
            <h:panelGroup id="preselectionTaxons" styleClass="listVariables">

                <rich:list value="#{uiBean.taxaPreselectedAvailables}" var="taxon"
                           id="listPreselection">
                    <h:outputLink value="#" onclick="selectTaxonVO(#{taxon.taxon.id})"
                                  rendered="true">
                        <h:outputText
                            value="#{taxon.localizedName} (#{taxon.localizedLevelName})"
                            styleClass="#{taxon.selected ? 'selected':''}" />
                        <h:graphicImage name="check.png" library="images"
                                        rendered="#{taxon.selected}" />
                    </h:outputLink>

                    <h:outputText
                        value="#{taxon.localizedName} (#{taxon.localizedLevelName})"
                        rendered="false" styleClass="disabled" />
                </rich:list>

            </h:panelGroup>
        </rich:tab>
        <rich:tab header="#{taxonchoicestep.PROPERTY_MSG_FREE_SEARCH}">
            <h:outputText value="#{taxonchoicestep.PROPERTY_MSG_SEARCH_BY_NAME}" />
            <h:inputText value="#{uiBean.taxonSearch}"
                         onkeyup="updateTaxonList(this.value)" />
            <h:panelGroup styleClass="panelControlsWrapper" layout="block">
                <h:panelGroup styleClass="panelControls">
                    <h:panelGroup styleClass="control" id="panelFreeSearch">
                        <a4j:commandLink
                            execute="@this,parametersRequest,tree,treePreselection"
                            styleClass="buttonStepNext" limitRender="true"
                            action="#{uiBean.addFreeTaxon}"
                            render="listTaxons,parametersRequest, prevStepButton, nextStepButton, validImage, messageWarningStep3,tree">
                            <h:graphicImage value="#{resource['images:add.png']}" />
                            <h:outputText value="#{taxonchoicestep.PROPERTY_MSG_LIST_TAXON}" />
                        </a4j:commandLink>
                    </h:panelGroup>
                </h:panelGroup>
            </h:panelGroup>
            <rich:list value="#{uiBean.taxonsAvailables}" var="taxon"
                       id="rechercheLibre">
                <h:outputLink value="#" onclick="selectTaxonVO(#{taxon.taxon.id})"
                              rendered="true">
                    <h:outputText
                        value="#{taxon.localizedName} (#{taxon.localizedLevelName})"
                        styleClass="#{taxon.selected ? 'selected':''}" />
                    <h:graphicImage name="check.png" library="images"
                                    rendered="#{taxon.selected}" />
                </h:outputLink>

                <h:outputText
                    value="#{taxon.localizedName} (#{taxon.localizedLevelName})"
                    rendered="false" styleClass="disabled" />
            </rich:list>
        </rich:tab>
        <rich:tab header="#{taxonchoicestep.PROPERTY_MSG_TAXON_TREE}">
            <rich:tree id="tree" var="node" toggleType="client"
                       binding="#{uiBean.treeListTaxon}" selectionType="ajax">
                <rich:treeModelRecursiveAdaptor roots="#{uiBean.rootNodes}"
                                                nodes="#{node.children}">
                    <rich:treeNode binding="#{uiBean.treeNodeTaxon}"
                                   expanded="#{node.expanded}">
                        <a4j:commandLink
                            value="#{node.taxon == null? taxonchoicestep.PROPERTY_MSG_TREE_PHYTO:node.taxon.localizedName}"
                            action="#{uiBean.deployNodeTaxon}"
                            execute="@this,parametersRequest" limitRender="true"
                            render="tree,parametersRequest,messageWarningStep3,taxonStepValid,nextStepButton">
                            <f:setPropertyActionListener
                                target="#{uiBean.treeNodeTaxonSelected}" value="#{node}" />
                        </a4j:commandLink>
                        <h:graphicImage name="check.png" library="images"
                                        rendered="#{node.taxon.selected}" />
                    </rich:treeNode>
                    <rich:treeModelAdaptor nodes="#{node.leaves}">
                        <rich:treeNode>
                            <a4j:commandLink value="#{node.taxon.localizedName}"
                                             action="#{uiBean.deployNodeTaxon}"
                                             execute="@this,parametersRequest" limitRender="true"
                                             render="tree,parametersRequest,messageWarningStep3,taxonStepValid,nextStepButton"
                                             styleClass="leaf">
                                <f:setPropertyActionListener
                                    target="#{uiBean.treeNodeTaxonSelected}" value="#{node}" />
                            </a4j:commandLink>
                            <h:graphicImage name="check.png" library="images"
                                            rendered="#{node.taxon.selected}" />
                        </rich:treeNode>
                    </rich:treeModelAdaptor>
                </rich:treeModelRecursiveAdaptor>
            </rich:tree>
        </rich:tab>
    </rich:tabPanel>

</html>